package io.tswf.groovy.bettergroovy.asm.member

import groovy.transform.CompileStatic
import org.objectweb.asm.Type

@CompileStatic
abstract class AbstractMember implements IMember {

    @Override
    boolean hasAnnotation(Type annotationType) {
        return annotations.any { it.desc == annotationType.descriptor }
    }

    @Override
    boolean hasAnnotation(Class annotationType) {
        return hasAnnotation(annotationType.asAsmType())
    }

    @Override
    boolean hasModifier(int mod) {
        return (modifiers & mod) != 0
    }
}
