package io.tswf.groovy.bettergroovy.asm.member

import groovy.transform.CompileStatic
import org.objectweb.asm.Type
import org.objectweb.asm.tree.AnnotationNode
import org.objectweb.asm.tree.ClassNode
import org.objectweb.asm.tree.FieldNode

@CompileStatic
class ClassNodeMember extends AbstractMember {
    ClassNode classNode

    ClassNodeMember(ClassNode classNode) {
        this.classNode = classNode
    }

    @Override
    String getName() {
        return classNode.javaName
    }

    @Override
    Type getType() {
        // Нельзя кэшировать потому, что ClassNode может меняться
        return classNode.asAsmType()
    }

    @Override
    ClassNode getOwner() {
        return null
    }

    @Override
    List<AnnotationNode> getAnnotations() {
        return classNode.allAnnotations
    }

    @Override
    int getModifiers() {
        return classNode.access
    }

    @Override
    boolean hasOwner() {
        return false
    }
}
