package io.tswf.groovy.bettergroovy.asm.member

import groovy.transform.CompileStatic
import org.objectweb.asm.Type
import org.objectweb.asm.tree.AnnotationNode
import org.objectweb.asm.tree.ClassNode
import org.objectweb.asm.tree.FieldNode

@CompileStatic
class FieldNodeMember extends AbstractMember {
    ClassNode owner
    FieldNode field

    FieldNodeMember(ClassNode owner, FieldNode field) {
        this.owner = owner
        this.field = field
    }

    @Override
    String getName() {
        return field.name
    }

    @Override
    Type getType() {
        // Нельзя кэшировать потому, что FieldNode может меняться
        return Type.getType(field.desc)
    }

    @Override
    List<AnnotationNode> getAnnotations() {
        return field.allAnnotations
    }

    @Override
    int getModifiers() {
        return field.access
    }

    @Override
    boolean hasOwner() {
        return owner != null
    }
}
