package io.tswf.groovy.bettergroovy.asm.member

import groovy.transform.CompileStatic
import org.objectweb.asm.Type
import org.objectweb.asm.tree.AnnotationNode
import org.objectweb.asm.tree.ClassNode
import org.objectweb.asm.tree.FieldNode
import org.objectweb.asm.tree.MethodNode

@CompileStatic
class MethodNodeMember extends AbstractMember {
    ClassNode owner
    MethodNode method

    MethodNodeMember(ClassNode owner, MethodNode method) {
        this.owner = owner
        this.method = method
    }

    @Override
    String getName() {
        return method.name
    }

    @Override
    Type getType() {
        // Нельзя кэшировать потому, что MethodNode может меняться
        return Type.getReturnType(method.desc)
    }

    @Override
    List<AnnotationNode> getAnnotations() {
        return method.allAnnotations
    }

    @Override
    int getModifiers() {
        return method.access
    }

    @Override
    boolean hasOwner() {
        return owner != null
    }
}
