package io.tswf.groovy.bettergroovy.asm.member.filters

import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.asm.member.IMember

@CompileStatic
class MemberFilters {

    static List<IGeneratedMemberFilter> generatedMemberFilters = ServiceLoader.load(IGeneratedMemberFilter).toList()
    static List<ITransientMemberFilter> transientMemberFilters = ServiceLoader.load(ITransientMemberFilter).toList()
    static List<IGroovyInternalMemberFilter> groovyInternalMemberFilters = ServiceLoader.load(IGroovyInternalMemberFilter).toList()

    static boolean isGenerated(IMember member) {
        return generatedMemberFilters.any { it.isGenerated(member) }
    }

    static boolean isTransient(IMember member) {
        return transientMemberFilters.any { it.isTransient(member) }
    }

    static boolean isGroovyInternal(IMember member) {
        return groovyInternalMemberFilters.any { it.isGroovyInternal(member) }
    }
}
