package io.tswf.groovy.bettergroovy.asm.scan

import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.asm.cache.ClassNodeCache
import io.tswf.groovy.bettergroovy.scan.ClasspathResourceScanner
import io.tswf.groovy.bettergroovy.scan.Resource
import org.objectweb.asm.tree.ClassNode

import java.util.function.Predicate
import java.util.stream.Stream

@CompileStatic
@Singleton(lazy = true)
class ClasspathClassScanner {

    Stream<String> findClassesInPackage(
            String packageName,
            Predicate<ClassNode> filter = {true},
            Predicate<Object> sourceFilter = { true },
            Iterable<?> sources = null

    ) {
        def classResources = System.findResourcesInPackage(
                packageName,
                {it.name.endsWith(".class")},
                sourceFilter,
                sources
        )

        return classResources
                .map { ClassNodeCache.instance.getClassNodeFromStream(it.inputStreamSupplier.get())}
                .filter {filter.test(it)}
                .map {it.javaName}
    }
}
