package io.tswf.groovy.bettergroovy.asm.tree.iterator

import groovy.transform.CompileStatic
import org.objectweb.asm.tree.AbstractInsnNode

@CompileStatic
class InsnsNextIterator implements Iterator<AbstractInsnNode> {

    AbstractInsnNode current

    InsnsNextIterator(AbstractInsnNode current) {
        this.current = current
    }

    @Override
    boolean hasNext() {
        return current.next != null
    }

    @Override
    AbstractInsnNode next() {
        if (current.next == null) {
            throw new NoSuchElementException("No next node present in ${current}!")
        }

        current = current.next
        return current
    }
}
