package io.tswf.groovy.bettergroovy.asm.util

import groovy.transform.CompileStatic

import static org.objectweb.asm.Opcodes.*

@CompileStatic
@Singleton(lazy = true)
class OpcodeUtil {
    SortedSet<Integer> returnOpcodes = new TreeSet<Integer>().tap {
        it.add(RETURN)
        it.add(IRETURN)
        it.add(LRETURN)
        it.add(DRETURN)
        it.add(ARETURN)
    }


    boolean isOpcodeReturn(int opcode) {
        return opcode in returnOpcodes
    }

    boolean isOpcodeExit(int opcode) {
        return opcode == ATHROW || isOpcodeReturn(opcode)
    }
}
